/* "Spritelib" demo application: draw background and a few fixed objects.
  Orion Sky Lawlor, olawlor@acm.org, 2010-04-05 (Public Domain) */
#include "spritelib/spritelib.h"
#include "spritelib/spritelib.cpp"
#include <list>

class cat {
public:
	float created; // lib.time when object was created
	float x,y; // center of cat
	
	void draw(spritelib &lib) {
		const float catSizeY=500;
		static spritelib_tex cat=lib.read_tex("cat.jpg");
		lib.draw(cat, // color
			x,y, // center
			500,catSizeY, // size
			20.0*sin(5.0*(lib.time-created))); // angle (degrees)
	}
};

void spritelib_draw_screen(spritelib &lib) {
	static spritelib_tex tex=lib.read_tex("sunset.jpg");
	
	for (int dx=-300;dx<+500;dx+=30)
	{
		float dy=100.0*sin((dx*0.1+60.0*lib.time)*3.14/180.0);
		lib.draw(tex, // color
			lib.mousex+dx,lib.mousey+dy, // center
			200,200);
	}
	
	static std::list<cat> cats; // all cats
	static float last_cat=0.0;
	const float time_per_cat=1.0/10.0; // 1.0/cats per second
	if (lib.mouseleft && lib.time>last_cat+time_per_cat) { // add new cat
		last_cat=lib.time;
		cat c;
		c.created=lib.time;
		c.x=lib.mousex; c.y=lib.mousey;
		cats.push_back(c);
	}
	
	// draw all existing cats
	for (std::list<cat>::iterator it=cats.begin();it!=cats.end();++it)
	{
		cat &c=(*it);
		c.y+=400.0*lib.dt; // cat's downward motion
		c.draw(lib);
		if (lib.time>c.created+3.0) {
			std::list<cat>::iterator doomed=it;
			--it;
			cats.erase(doomed);
		}
	}
}

int main(int argc,char *argv[]) 
{
	spritelib_run("SpriteLib Animation Test 7",1300,900);
	return 0;
}
