/* "Spritelib" demo application: draw background and a few fixed objects.
  Orion Sky Lawlor, olawlor@acm.org, 2010-04-05 (Public Domain) */
#include "spritelib/spritelib.h"
#include "spritelib/spritelib.cpp"

void spritelib_draw_screen(spritelib &lib) {
/* Background */
	static spritelib_tex background=lib.read_tex("sunset.jpg");
	float ken_burns=1.1-0.1*cos(0.15*lib.time); // slowly zoom in and out
	lib.draw(background,lib.screenw/2.0,lib.screenh/2.0,
		lib.screenw*ken_burns,lib.screenh*ken_burns);
	
/* Player character */
	static spritelib_tex cat=lib.read_tex("cat.jpg");
	lib.draw(cat,
		lib.mousex, // position
		lib.mousey,
		lib.mouseleft?300:100, // size
		lib.key[' ']?300:100,
		180); // angle cat facing up
	
/* Onscreen ordinance */
	static spritelib_tex glow=lib.read_tex("glow.jpg");
	const float shot_size=30.0;
	for (float shot=1.0; shot<100.0; shot++)
	{
		lib.draw(glow,
			lib.mousex, // position
			lib.mousey-shot*1.5*shot_size,
			shot_size*(1.0+shot*0.2), // size
			shot_size*(1.0+shot*0.2),
			lib.time*shot*20.0, // angle
			true); // glow!
	}
}

int main(int argc,char *argv[]) 
{
	spritelib_run("SpriteLib Demo",800,600);
	return 0;
}
